# Copyright 2022 D-Wave Systems Inc.
#
#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at
#
#        http://www.apache.org/licenses/LICENSE-2.0
#
#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

# as of Cython 0.29.28, __annotations__ are not included for Cython objects.
# so we specify their types here.

from typing import Hashable, Iterable, Iterator, Mapping, Optional, TypeVar, overload

T = TypeVar("T")

class cyRegister:
    def __init__(self, iterable: Optional[Iterable[Hashable]] = None): ...
    def __contains__(self, v: Hashable) -> bool: ...
    def __copy__(self: T) -> T: ...
    @overload
    def __getitem__(self, idx: int) -> Hashable: ...
    @overload
    def __getitem__(self: T, idx: slice) -> T: ...
    def __iter__(self) -> Iterator[Hashable]: ...
    def __len__(self) -> int: ...
    def _append(self, v: Optional[Hashable] = None, permissive: bool = False) -> Hashable: ...
    def _clear(self) -> None: ...
    def _is_range(self) -> bool: ...
    def _extend(self, iterable: Iterable[Hashable], permissive: bool = False) -> None: ...
    def _pop(self) -> Hashable: ...
    def _relabel(self, mapping: Mapping[Hashable, Hashable]) -> None: ...
    def _relabel_as_integers(self) -> Mapping[int, Hashable]: ...
    def _remove(self, v: Hashable) -> None: ...
    def copy(self: T) -> T: ...
    def count(self, v: Hashable) -> int: ...
    def index(self, v: Hashable, permissive: bool = False) -> int: ...
